﻿import requests, json, execjs, os, re, random, time, uuid
from jsonpath import jsonpath
from app.loadmodel import gt4iconweb3 
from urllib import request
from typing import Union 
from urllib.parse import urljoin
from loguru import logger
from webjs.icon4.tools import xyxy2gtformat, download_img, headers, cookies, now_str




def download_img(url: Union[str, list], path: Union[str, list]) -> None:
    """
    通过url下载图片,已经被 urllib.request 封装好了的
    :param url: 图片url
    :param path: 保存路径,带后缀名
    """
    if isinstance(url, str) and isinstance(path, str):
        os.makedirs(os.path.dirname(path), exist_ok=True)
        request.urlretrieve(url, path)

    elif isinstance(url, list) and isinstance(path, list):
        assert len(url) == len(path), "url和path长度不一致"
        for i in range(len(url)):
            request.urlretrieve(url[i], path[i])



session = requests.Session()
def get_data(captcha_id):
    headers = {
        'Accept': '*/*',
        'Accept-Language': 'zh-CN,zh;q=0.9',
        'Cache-Control': 'no-cache',
        'Connection': 'keep-alive',
        'Pragma': 'no-cache',
        'Referer': 'https://www.okx.com/',
        'Sec-Fetch-Dest': 'script',
        'Sec-Fetch-Mode': 'no-cors',
        'Sec-Fetch-Site': 'cross-site',
        'User-Agent': 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_15_7) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/123.0.0.0 Safari/537.36',
        'sec-ch-ua': '"Google Chrome";v="123", "Not:A-Brand";v="8", "Chromium";v="123"',
        'sec-ch-ua-mobile': '?0',
        'sec-ch-ua-platform': '"macOS"',
    }

    params = {
        'captcha_id': captcha_id,
        'challenge': str(uuid.uuid4()),
        'client_type': 'web',
        'risk_type': 'icon',
        'lang': 'zho',
        'callback': f'geetest_{int(time.time() * 1000)}',
    }
    response = session.get('https://gcaptcha4.geetest.com/load', params=params, headers=headers)
    res= response.text
    data = json.loads(res[res.find("(") + 1:res.rfind(")")] )
    return data







def process_data(data):
    imgs = jsonpath(data, '$..imgs')[0]
    ques = jsonpath(data, '$..ques')[0]
    if isinstance(imgs, str):
        imgs = [imgs]
    base_url = "https://static.geetest.com/"
    for i in range(len(imgs)):
        imgs[i] = urljoin(base_url, imgs[i])
    for i in range(len(ques)):
        ques[i] = urljoin(base_url, ques[i])
    os.makedirs("temp3", exist_ok=True)
    imgs_path = [f"temp3/imgs{i}.png" for i in range(len(imgs))]
    ques_path = [f"temp3/ques_{i}.png" for i in range(len(ques))]

    download_img(imgs, imgs_path)
    download_img(ques, ques_path)
    return imgs_path, ques_path


if __name__ == '__main__':
    gt = captcha_id = '6ba6b71b4f3958a1c69ad839ba47836b'
    data = get_data(captcha_id)
    imgs_path, ques_path = process_data(data)
    out = gt4iconweb3.run(imgs_path[0], ques_path)
    xyxy = out.targets_xyxy
    userresponse = xyxy2gtformat(xyxy)


    with open("webjs/icon4/demo_g4icon.js", "r") as f:
        jscode = f.read()
    ctx = execjs.compile(jscode)

    json_data = data
    lot_number = jsonpath(json_data, '$..lot_number')[0]
    pow_detail = jsonpath(json_data, '$..pow_detail')[0]
    detail_time = jsonpath(pow_detail, '$..datetime')[0]
    payload = jsonpath(json_data, '$..payload')[0]
    process_token = jsonpath(json_data, '$..process_token')[0]
    
    time.sleep(random.uniform(1.5, 2.5))

    w = ctx.call("get_w2", gt, lot_number, detail_time, userresponse)
    params = {
        'callback': f'geetest_{int(time.time() * 1000)}',
        'captcha_id': gt,
        'client_type': 'web',
        'lot_number': lot_number,
        'risk_type': 'icon',
        'payload': payload,
        'process_token': process_token,
        'payload_protocol': '1',
        'pt': '1',
        'w': w,
    }


    with open("params.json", "w") as f:
        f.write(json.dumps(params, indent=2, ensure_ascii=False))

    response = session.get('https://gcaptcha4.geetest.com/verify', 
                           params=params, cookies=cookies, headers=headers)
    print(response.text)    
    data = json.loads(response.text[response.text.find("(") + 1:response.text.rfind(")")])
    with open("a111.json", "w") as f:
        f.write(json.dumps(data, indent=4, ensure_ascii=False))
